package net.ligent.students.transportation;

public class Car {
	
	// instance variables
	private String make;
	private String model;
	private int year;
	private String color;
	private String fuelType;
	private String vehicleIdNumber;
	
	// class constants
	public static final String GAS = "Gas";
	public static final  String DIESEL = "Diesel";
	public static final String  ELECTRIC = "Electric";
	
	
	// constructors
	public Car() {
		// no-argument constructor
	}
	
	public Car(String make, String model, int year, String color, 
			String fuelType, String vehicleIdNumber) {
		// overloaded constructor
		setMake(make);
		setModel(model);
		setYear(year);
		setColor(color);
		setFuelType(fuelType);
		setVehicleIdNumber(vehicleIdNumber);
	}


	// getters and setters
	public String getMake() {
		return make;
	}
	public void setMake(String make) {
		this.make = make;
	}
	public String getModel() {
		return model;
	}
	public void setModel(String model) {
		this.model = model;
	}
	public int getYear() {
		return year;
	}
	public void setYear(int year) {
		this.year = year;
	}
	public String getColor() {
		return color;
	}
	public void setColor(String color) {
		this.color = color;
	}
	public String getFuelType() {
		return fuelType;
	}
	public void setFuelType(String fuelType) {
		this.fuelType = fuelType;
	}
	public String getVehicleIdNumber() {
		return vehicleIdNumber;
	}
	public void setVehicleIdNumber(String vehicleIdNumber) {
		this.vehicleIdNumber = vehicleIdNumber;
	}

	@Override
	public String toString() {
		return "Car [make=" + make + ", model=" + model + ", year=" + year + ", color=" + color + ", fuelType="
				+ fuelType + ", vehicleIdNumber=" + vehicleIdNumber + "]";
	}

	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result + ((color == null) ? 0 : color.hashCode());
		result = prime * result + ((fuelType == null) ? 0 : fuelType.hashCode());
		result = prime * result + ((make == null) ? 0 : make.hashCode());
		result = prime * result + ((model == null) ? 0 : model.hashCode());
		result = prime * result + year;
		return result;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		Car other = (Car) obj;
		if (color == null) {
			if (other.color != null)
				return false;
		} else if (!color.equals(other.color))
			return false;
		if (fuelType == null) {
			if (other.fuelType != null)
				return false;
		} else if (!fuelType.equals(other.fuelType))
			return false;
		if (make == null) {
			if (other.make != null)
				return false;
		} else if (!make.equals(other.make))
			return false;
		if (model == null) {
			if (other.model != null)
				return false;
		} else if (!model.equals(other.model))
			return false;
		if (year != other.year)
			return false;
		return true;
	}
	
	// other (worker) methods
	
	public double determineAnnualRegistrationFee() {
		double answer = 0.00;
		if (getFuelType() == null) {
			answer = 150.00;
		}
		else if (getFuelType().equals(ELECTRIC)) {
			answer = 50.00;
		} else if (getFuelType().equals(GAS)) {
			answer = 100.00;
		} else {
			answer = 150.00;
		}
		return answer;
	}
	
}
